/* This example shows how to use continuous mode to take
range measurements with the VL53L0X. It is based on
vl53l0x_ContinuousRanging_Example.c from the VL53L0X API.

The range readings are in units of mm. */
//this is an example for fast filtering for analog measurments
#include <Wire.h>
#include "VL53L0X.h"
#include "noisefilterbox.h" //this is code written by me and being tested
VL53L0X sensor;
#define limits 2

byte data=0;
float average=0.0;//we have two averages, when both numbers are within a set range of 2-0.1 we assume stabel measurement
float averageA=0.0;
float averageB=0.0;
byte incomingByte=0;
byte datacache=0;
byte count=0;
int presample =50;//we use this to buffer differences between two measures
float non_spike_average=0.0;
void setup()
{delay(5000);//make easier to program
  Serial.begin(19200);
  Wire.begin();

  sensor.setTimeout(500);
  if (!sensor.init())
  {
    Serial.println("Failed to detect and initialize sensor!");
    while (1) {}
  }

  // Start continuous back-to-back mode (take readings as
  // fast as possible).  To use continuous timed mode
  // instead, provide a desired inter-measurement period in
  // ms (e.g. sensor.startContinuous(100)).
  sensor.startContinuous();

}


//review modes 1 to 3 when back home
void loop()
{

//while (Serial.available() > 0){
  
  float sense=sensor.readRangeContinuousMillimeters();
  //we then look at data that is beyond noise. this indicates a fast shift

  //we reduce noise spikes by reducing effect, but all owing a slight correction
 //float num_dif=0.0;

bool stable=false;//if true and signal is not filtered very well you might get all zero's returned
int FilterMode=3;

float output=filterNoiseReductionBox(sense,FilterMode,stable);//we get meaurement
Serial.println(output,4);

  delay(30);
//}


 

 //incomingByte = Serial.read();
}
