//filter that suppresses noise but still allows for fast change
//desgined for example applications by james villeneuve jan 2021
// to add just use '   #include "noisefilterbox.h"  ' and add this file to program folder. 


//this code allows for noise suppresion and recognizing when noise is removed from signal. 
//there are 4 FilterModes that allow for testing, and can be switched per sample on the fly
//FilterMode==0 this is no filtering
//FilterMode==1 this is averaging filtering and it sampes based on Filt_samples_To_average but it has a slow change rate
//FilterMode==2 this uses aveaging filter, but also uses a lower sampler filter when signal change          
//FilterMode==3 this uses a hybrid filtering. the steaper the changes in the data, the greater the gains





#define bumpdown1_if_true false //we build this in to see in troubleshooting when stable

#define Filt_largest_value_in_amplitude_of_signal 255 //we take the largest value we will see in amplitude. this helps with noise calc
#define Filt_smallest_value_in_amplitude_of_signal 0 //-255 //we take the largest value we will see in amplitude. this helps with noise calc
#define Filt_stable_percentage_return 0.1 //0.1% of 255 values //if we want to know signal is stable this tells us when its variation is less than 0.25
#define Filt_signal_to_noise_ratio 10 //this is ratio applied to inverse noise filter
#define scale_of_Long 1000000 //this allows use more number control to keep out of inacuracies of floats precisions
float FiltAvgA=0.0;//this is regular sample filter
float FiltAvgB=0.0;//this is regular sample filter
long  Filt_stablizedA=0;
long  Filt_stablizedB=0;
float result_of_stability=0.0;
long  longFiltAvgA=0;
long  longFiltAvgB=0;
long  longFiltAvgC=0;
long  scaled_AnalogfloatSignalInput=0;//this is a number up to ~ +/-2,147,483,648 that we scale analog value for processing
float filterNoiseReductionBox(float AnalogfloatSignalInput,int FilterMode, bool isItStable){
//noise reduction with faster response rates example by james villeneuve jan 2021
//conversion variables we can constently convert from 64bit ide floats to software longs
//we keep these here inside of loop because they never change, they just recompute values to not need division
//all values are converted to floats that are calculated inside ide to 64bit float. none of these values
//are calculated in arduino 32 bit float. the precision is set from scale_of_long which with 100000 is
//equivilent to decimal value of +/- 0.00001 precision at every value
#define Filt_samples_To_average_deimalFloat long(scale_of_Long *float(float(1)/Filt_samples_To_average)) //arduino ide has hard floats as 64bit
#define Filt_signal_to_noise_ratio_deimalFloat (float(Filt_signal_to_noise_ratio-float(1))/Filt_signal_to_noise_ratio) //arduino ide has hard floats as 64bit
#define Filt_signal_to_noise_ratioInverted_deimalFloat (float(float(1))/Filt_signal_to_noise_ratio) 
#define scale_of_Long_deimalFloat float(float(1)/scale_of_Long)//.this is for reverse
#define scale_of_max long(Filt_largest_value_in_amplitude_of_signal*scale_of_Long) //we solve here once during compile
#define scale_of_min long(Filt_smallest_value_in_amplitude_of_signal*scale_of_Long) //we solve here once during compile
#define Filt_samples_To_average_deimalFloat (float(float(Filt_samples_To_average-1)/Filt_samples_To_average)) //arduino ide has hard floats as 64bit
#define Filt_samples_To_average_deimalFloatInverse float(float(1)/Filt_samples_To_average)


  scaled_AnalogfloatSignalInput=long(AnalogfloatSignalInput *scale_of_Long);// we store value at scale




//******** this determines if part of transform is stable  *********************************************
if (FilterMode>0){//stable test filteMode must be at least 1 to see if singal stablized
  result_of_stability=0.0;
  longFiltAvgA=long(longFiltAvgA*0.99) +long(scaled_AnalogfloatSignalInput*0.01);//we hae a 100x filter signal to look at wave 
  Filt_stablizedA=long(Filt_stablizedA*0.51)+ long(longFiltAvgA*0.49);//we keep a sample of 10x of signal to verify difference of current and previous sample change
  Filt_stablizedB=long(Filt_stablizedA*0.49)+ long(longFiltAvgA*0.51);
  if (Filt_stablizedB !=0 & Filt_stablizedA !=0){//trying a little more agressive curve for filter
  result_of_stability=(float(Filt_stablizedB-Filt_stablizedA)*scale_of_Long_deimalFloat)*(float(Filt_stablizedB-Filt_stablizedA)*scale_of_Long_deimalFloat)*(float(Filt_stablizedB-Filt_stablizedA)*scale_of_Long_deimalFloat)*200;}//this is still scaled
 
  if (result_of_stability<0 ){result_of_stability=-result_of_stability;}//we compare to refference for if it is stable. default is 1% change or less
    //this just means if percentage of signal change is less than percent of Filt_stable_percentage_return we return a
  
}


//**** this returns raw data no filtering*********************************************
 if (FilterMode==0){return scaled_AnalogfloatSignalInput*scale_of_Long_deimalFloat;}
//************************************************************************************


//*****************************************************************************************************
//** this returns 0 if isItStable is set in function, if value is stable or isItStable is false it returns a 10x filtered value
if (FilterMode==1){//we do a 10x sampling 
longFiltAvgB=long(longFiltAvgB*0.9) +long(scaled_AnalogfloatSignalInput*0.1);//we scale back down and do final conversion to less precise 32bit float
                                                  
if (isItStable==true){//this means we do a check if largest possible signal * Filt_stable_percentage_return/100
   if (result_of_stability>  Filt_stable_percentage_return*float((Filt_largest_value_in_amplitude_of_signal- Filt_smallest_value_in_amplitude_of_signal)/100)){
 return 0;}}
  return float(longFiltAvgB*scale_of_Long_deimalFloat);}//either isItstable is true, or it is not enabeld so returns
//************************************************************************************



//******************************************************************************************************************************
//** this returns 0 if isItStable is set in function, if value is stable or isItStable is false it returns a 100x filtered value
if (FilterMode==2){//we do a 10x sampling 

longFiltAvgB=long(longFiltAvgB*0.99) +long(scaled_AnalogfloatSignalInput*0.01);//

if (isItStable==true){//this means we do a check if largest possible signal * Filt_stable_percentage_return/100
   if (result_of_stability>  Filt_stable_percentage_return*float((Filt_largest_value_in_amplitude_of_signal- Filt_smallest_value_in_amplitude_of_signal)/100)){
 return 0;}}
  return float(longFiltAvgB*scale_of_Long_deimalFloat);}//either isItstable is true, or it is not enabeld so returns
//******************************************************************************************************************************



//****** hybrid variabel filtering *********************************************************************************************
if (FilterMode==3){//we do a variebls sampling from 1x to 1000x

float tempscalingValue=result_of_stability;
//practical limits to remove oscolation
if (tempscalingValue<0.5){tempscalingValue=0.5;}
if (tempscalingValue>0.9999){tempscalingValue=0.9999;}
longFiltAvgB=longFiltAvgB*float(1-tempscalingValue) +longFiltAvgA*tempscalingValue;//

if (isItStable==true){//this means we do a check if largest possible signal * Filt_stable_percentage_return/100
   if (result_of_stability>  Filt_stable_percentage_return*float((Filt_largest_value_in_amplitude_of_signal- Filt_smallest_value_in_amplitude_of_signal)/100)){
 return 0;}}

 #if bumpdown1_if_true == true
  if (result_of_stability<  Filt_stable_percentage_return*float((Filt_largest_value_in_amplitude_of_signal- Filt_smallest_value_in_amplitude_of_signal)/100)){
  longFiltAvgC=longFiltAvgC*0.9+longFiltAvgB*0.1;
 return -1+longFiltAvgC*scale_of_Long_deimalFloat;}}//either isItstable is true, or it is not enabeld so returns
else{longFiltAvgC=longFiltAvgC*0.9+longFiltAvgB*0.1;
 return longFiltAvgC*scale_of_Long_deimalFloat;}
}
 #endif
 #if bumpdown1_if_true == false
 //longFiltAvgB*scale_of_Long_deimalFloat;}//either isItstable is true, or it is not enabeld so returns
 longFiltAvgC=longFiltAvgC*0.9+longFiltAvgB*0.1;
 return longFiltAvgC*scale_of_Long_deimalFloat;}
 //********************************************************************************************* 
 #endif

   
 
 
//end of function
}
